/************************************************************************/
/* XvicCopyRawCall_zoom.h						*/
/* This code is repeated for easy and hard zooms.  It generates calls	*/
/* to separate functions (generated by XvicCopyRawFn_zoom.h) based on	*/
/* the data type (byte vs. half/uhalf vs. other) and display mode	*/
/* color vs. pseudo vs. bw).						*/
/************************************************************************/

#ifdef DTYPE
#undef DTYPE
#endif
#ifdef MODE
#undef MODE
#endif

   if (biw->bim.data_type == XvicBYTE && biw->bim.lut16_type == XvicRAW) {

#define DTYPE DTYPE_BYTE

      if (biw->bim.image_mode == XvicCOLOR) {

#define MODE MODE_COLOR

#include "XvicCopyRaw_name.h"
         FN_NAME(3band)(ARG_LIST);

      }
      else {				/* BW, pseudo */

#undef MODE
#define MODE MODE_BW

#include "XvicCopyRaw_name.h"
         FN_NAME(1band)(ARG_LIST);

      }
   }
   else if (biw->bim.data_type == XvicHALF || biw->bim.data_type == XvicUHALF) {

#undef DTYPE
#define DTYPE DTYPE_HALF

      if (biw->bim.image_mode == XvicCOLOR) {

#undef MODE
#define MODE MODE_COLOR

#include "XvicCopyRaw_name.h"
         FN_NAME(3band)(ARG_LIST);

      }
      else if (biw->bim.lut16_type == XvicPSEUDO ||
               biw->bim.lut16_type == XvicPSEUDO_ONLY) {

#undef MODE
#define MODE MODE_PSEUDO

#include "XvicCopyRaw_name.h"
         FN_NAME(3band)(ARG_LIST);

      }
      else {

#undef MODE
#define MODE MODE_BW

#include "XvicCopyRaw_name.h"
         FN_NAME(1band)(ARG_LIST);

      }
   }
   else {						/* other data type */

#undef DTYPE
#define DTYPE DTYPE_OTHER

      if (biw->bim.image_mode == XvicCOLOR) {

#undef MODE
#define MODE MODE_COLOR

#include "XvicCopyRaw_name.h"
         FN_NAME(3band)(ARG_LIST);

      }
      else if (biw->bim.lut16_type == XvicPSEUDO ||
	       biw->bim.lut16_type == XvicPSEUDO_ONLY) {

#undef MODE
#define MODE MODE_PSEUDO

#include "XvicCopyRaw_name.h"
         FN_NAME(3band)(ARG_LIST);

      }
      else {

#undef MODE
#define MODE MODE_BW

#include "XvicCopyRaw_name.h"
         FN_NAME(1band)(ARG_LIST);

      }
   }

